> For the complete documentation index, see [llms.txt](https://docs.atfinity.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.atfinity.io/rule-language/operators/string-operators/format.md).

# format

### Description

`format` takes a string and replaces all placeholders with values provided for them.

### Example: Formatting a Person Name

```
p is Person
"{name} {surname}".format(name: p.first_name, surname: p.last_name)
```

It is common practice to have two separate[ information fields](/guides/glossary/information.md) for a name - one for the first and one for the last name. If, once these data are collected, you want to treat the full name as one combined piece of information, you could use `format` like in the example above which returns a name like "Bruce Wayne".

### Example: For an E-Mail

The format operator is also very useful if you want to insert collected information into a larger string, e.g. an email. Let's say you would like to inform a client called "Clark Kent" about three new messages, then you could use the format operator like this:

```
p is Person
"Dear {name} {surname}

You have {new_messages} new messages."
.format(
    name: p.first_name,
    surname: p.last_name,
    new_messages: p.nr_of_new_messages
)
```

This would return the following message:

> Dear Clark Kent\
> You have 3 new messages.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.atfinity.io/rule-language/operators/string-operators/format.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
